//=====================================================================
//	 .
//=====================================================================
//---------------------------------------------------------------------
#property copyright 	"Dima S."
#property link      	"dimascub@mail.com"
#property version   	"1.00"
#property description "     ADX."
//---------------------------------------------------------------------
#property indicator_separate_window
//---------------------------------------------------------------------
#property indicator_applied_price	PRICE_CLOSE
#property indicator_minimum				-1.4
#property indicator_maximum				+1.4
//---------------------------------------------------------------------
#property indicator_buffers 	1
#property indicator_plots   	1
//---------------------------------------------------------------------
#property indicator_type1   	DRAW_HISTOGRAM
#property indicator_color1  	Black
#property indicator_width1		2
//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
input int   PeriodADX=14;
input int   ADXTrendLevel=20;
//---------------------------------------------------------------------
double      TrendBuffer[];
//---------------------------------------------------------------------
int         indicator_handle=0;
//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
int OnInit()
  {
//	  :
   SetIndexBuffer(0,TrendBuffer,INDICATOR_DATA);
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,PeriodADX*2);
   PlotIndexSetString(0,PLOT_LABEL,"ADXTrendDetector( "+(string)PeriodADX+" )");

//	        :
   ResetLastError();
   indicator_handle=iCustom(Symbol(),PERIOD_CURRENT,"Examples\\ADX",PeriodADX);
   if(indicator_handle==INVALID_HANDLE)
     {
      Print("  ADX,  = ",GetLastError());
      return(-1);   //    -   
     }

   return(0);
  }
//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
void OnDeinit(const int _reason)
  {
//	  :
   if(indicator_handle!=INVALID_HANDLE)
     {
      IndicatorRelease(indicator_handle);
     }
  }
//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
int OnCalculate(const int _rates_total,
                const int _prev_calculated,
                const int _begin,
                const double &_price[])
  {
   int start,i;

//	     ,   ADX,    :
   if(_rates_total<PeriodADX*2)
     {
      return(0);
     }

//	      :
   if(_prev_calculated==0)
     {
      start=PeriodADX*2;
     }
   else
     {
      start=_prev_calculated-1;
     }

//	    :
   for(i=start; i<_rates_total; i++)
     {
      TrendBuffer[i]=TrendDetector(_rates_total-i-1);
     }

   return(_rates_total);
  }
//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
//	:
//		-1 -  ;
//		+1 -  ;
//		 0 -   ;
//---------------------------------------------------------------------
int TrendDetector(int _shift)
  {
   int      trend_direction=0;
   double   ADXBuffer[1];
   double   PlusDIBuffer[1];
   double   MinusDIBuffer[1];

//	   ADX  :
   CopyBuffer(indicator_handle,0,_shift,1,ADXBuffer);
   CopyBuffer(indicator_handle,1,_shift,1,PlusDIBuffer);
   CopyBuffer(indicator_handle,2,_shift,1,MinusDIBuffer);

//	   ADX (   ):
   if(ADXTrendLevel>0)
     {
      if(ADXBuffer[0]<ADXTrendLevel)
        {
         return(trend_direction);
        }
     }

//	  +-DI   :
   if(PlusDIBuffer[0]>MinusDIBuffer[0])
     {
      trend_direction=1;
     }
   else if(PlusDIBuffer[0]<MinusDIBuffer[0])
     {
      trend_direction=-1;
     }

   return(trend_direction);
  }
//+------------------------------------------------------------------+