//=====================================================================
//	 .
//=====================================================================
#include <MovingAverages.mqh>
//---------------------------------------------------------------------
#property copyright 	"Dima S."
#property link      	"dimascub@mail.com"
#property version   	"1.00"
#property description "     ."
//---------------------------------------------------------------------
#property indicator_separate_window
//---------------------------------------------------------------------
#property indicator_applied_price	PRICE_CLOSE
#property indicator_minimum				-1.4
#property indicator_maximum				+1.4
//---------------------------------------------------------------------
#property indicator_buffers 	1
#property indicator_plots   	1
//---------------------------------------------------------------------
#property indicator_type1   	DRAW_HISTOGRAM
#property indicator_color1  	Black
#property indicator_width1		2
//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
input int   MAPeriod=200;   //    
//---------------------------------------------------------------------
//	 :
//---------------------------------------------------------------------
double      TrendBuffer[];
//---------------------------------------------------------------------
//	  :
//---------------------------------------------------------------------
void OnInit()
  {
//	  :
   SetIndexBuffer(0,TrendBuffer,INDICATOR_DATA);
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,MAPeriod);
   PlotIndexSetString(0,PLOT_LABEL,"MATrendDetector( "+(string)MAPeriod+" )");
  }
//---------------------------------------------------------------------
//	    :
//---------------------------------------------------------------------
int OnCalculate(const int _rates_total,
                const int _prev_calculated,
                const int _begin,
                const double &_price[])
  {
   int         start,i;

//	     ,   ,   :
   if(_rates_total<MAPeriod)
     {
      return(0);
     }

//	      :
   if(_prev_calculated==0)
     {
      start=MAPeriod;
     }
   else
     {
      start=_prev_calculated-1;
     }

//	    :
   for(i=start; i<_rates_total; i++)
     {
      TrendBuffer[i]=TrendDetector(i,_price);
     }

   return(_rates_total);
  }
//---------------------------------------------------------------------
//	   :
//---------------------------------------------------------------------
//	:
//		-1 -  ;
//		+1 -  ;
//		 0 -   ;
//---------------------------------------------------------------------
int TrendDetector(int _shift,const double &_price[])
  {
   double current_ma;
   int trend_direction=0;

   current_ma=SimpleMA(_shift,MAPeriod,_price);

   if(_price[_shift]>current_ma)
     {
      trend_direction=1;
     }
   else if(_price[_shift]<current_ma)
     {
      trend_direction=-1;
     }

   return(trend_direction);
  }
//+------------------------------------------------------------------+
